/*
 * @(#)IKApplication.cpp	1.00 10th June 2000
 * 
 * Contains functions to implement the sample application that IKTool
 * demonstrates.
 *
 * Modification Log:
 */

/**
 *
 * IKTool is a sample application using iKey, an user identity token from
 * Rainbow Technologies (http://www.rainbow.com).
 * Using this application you can personalize an iKey, and store data either
 * protected with a pin number or without protection, as you desire.
 * 
 * Several generic functions have been written for iKey, so that they
 * can be used with any type of application. 
 * 
 * You are free to use this code and to make modifications provided
 * this notice is retained.
 * <p>
 * If you found this useful, please add a note of acknowledgement to my guestbook,
 * or send me a mail at <a href="mailto:tanmaykm@hotmail.com">tanmaykm@hotmail.com</a>. 
 * If you would like to report a bug or suggest some improvements, 
 * you are most welcome. I will be happy to help you use this piece of code.
 * <p>
 *
 * @author 	    Tanmay K. Mohapatra
 * @version     1.00, 10th June, 2000
 */

#ifndef IKAPPLICATION_HXX
#define IKAPPLICATION_HXX


// Calculation of file size for our application
// Our Data:          32
// HMAC Key1 File:    16
// HMAC Key2 File:    16
//----------------------
//                    64 ~ 128

#define MAX_IKEY_USER_INFO_SIZE 0x20 // 32 bytes
#define DIRECTORY_SIZE 0x80 // 128 bytes

#define READ_MODE 0
#define WRITE_MODE 1
#define CREATE_MODE 2

int __stdcall AccessPinUserIKey(int iMode, unsigned char *sData, unsigned char DataLen, unsigned char *Pin, char *sMessage);
int __stdcall AccessPlainUserIKey(int iWriteMode, unsigned char *sData, unsigned char DataLen, char *sMessage);
int __stdcall UnblockPinUserIKey(unsigned char *Pin, char *sMessage);
int __stdcall ChangePinInUserIKey(unsigned char *OldPin, unsigned char *NewPin, char *sMessage);

#endif /* IKAPPLICATION_HXX */
