/*
 * @(#)IKConnectTool.hxx	1.00 10th June 2000
 * 
 * Functions that take care of connecting to the iKey mounted through
 * the USB port of your machine.
 *
 * Modification Log:
 */

/**
 *
 * IKTool is a sample application using iKey, an user identity token from
 * Rainbow Technologies (http://www.rainbow.com).
 * Using this application you can personalize an iKey, and store data either
 * protected with a pin number or without protection, as you desire.
 * 
 * Several generic functions have been written for iKey, so that they
 * can be used with any type of application. 
 * 
 * You are free to use this code and to make modifications provided
 * this notice is retained.
 * <p>
 * If you found this useful, please add a note of acknowledgement to my guestbook,
 * or send me a mail at <a href="mailto:tanmaykm@hotmail.com">tanmaykm@hotmail.com</a>. 
 * If you would like to report a bug or suggest some improvements, 
 * you are most welcome. I will be happy to help you use this piece of code.
 * <p>
 *
 * @author 	    Tanmay K. Mohapatra
 * @version     1.00, 10th June, 2000
 */


#ifndef IKCONNECTTOOL_HXX
#define IKCONNECTTOOL_HXX

#ifndef TOKENITF_H
#define TOKENITF_H
#include "Tokenitf.h"
#endif /* TOKENITF_H */

int ConnectIKey(PRNBTKN_CONTEXT pContext, unsigned long *plSysErr, char *sMsg);
int DisconnectIKey(PRNBTKN_CONTEXT pContext, unsigned long *plSysErr, char *sMsg);
int ResetIKey(PRNBTKN_CONTEXT pContext, unsigned long *plSysErr, char *sMsg);

#endif /* IKCONNECTTOOL_HXX */
