/*
 * @(#)IKFileTool.hxx	1.00 10th June 2000
 * 
 * Functions that take care of file manipulations on an iKey.
 *
 * Modification Log:
 */

/**
 *
 * IKTool is a sample application using iKey, an user identity token from
 * Rainbow Technologies (http://www.rainbow.com).
 * Using this application you can personalize an iKey, and store data either
 * protected with a pin number or without protection, as you desire.
 * 
 * Several generic functions have been written for iKey, so that they
 * can be used with any type of application. 
 * 
 * You are free to use this code and to make modifications provided
 * this notice is retained.
 * <p>
 * If you found this useful, please add a note of acknowledgement to my guestbook,
 * or send me a mail at <a href="mailto:tanmaykm@hotmail.com">tanmaykm@hotmail.com</a>. 
 * If you would like to report a bug or suggest some improvements, 
 * you are most welcome. I will be happy to help you use this piece of code.
 * <p>
 *
 * @author 	    Tanmay K. Mohapatra
 * @version     1.00, 10th June, 2000
 */


#ifndef IKFILETOOL_HXX
#define IKFILETOOL_HXX

#ifndef TOKENITF_H
#define TOKENITF_H
#include "Tokenitf.h"
#endif /* TOKENITF_H */

int OpenIKeyFile(PRNBTKN_CONTEXT pContext, unsigned long lDir, unsigned long lFile, unsigned long *plSysErr, char *sMsg);
void GetOpenFileInfo(PRNBTKN_CONTEXT pContext, unsigned long *plFileSize, int *piReadAccess, int *piWriteAccess, int *piCryptAccess, unsigned char *pcFileType);
int CloseIKeyFile(PRNBTKN_CONTEXT pContext, unsigned long *plSysErr, char *sMsg);
int ReadIKeyFile(PRNBTKN_CONTEXT pContext, unsigned char *sBuff, unsigned long *plLen, unsigned long *plSysErr, char *sMsg);
int WriteIKeyFile(PRNBTKN_CONTEXT pContext, unsigned char *sBuff, unsigned long *plLen, unsigned long *plSysErr, char *sMsg);
int DelIKeyDir(PRNBTKN_CONTEXT pContext, unsigned long lDir, unsigned long *plSysErr, char *sMsg);
int DelIKeyFile(PRNBTKN_CONTEXT pContext, unsigned long lDir, unsigned long lFile, unsigned long *plSysErr, char *sMsg);
int CreateIKeyDir(PRNBTKN_CONTEXT pContext, unsigned long lDir, unsigned long lLen, unsigned long *plSysErr, char *sMsg);
int CreateIKeyFile(PRNBTKN_CONTEXT pContext, 
				   unsigned long lDir, 
				   unsigned long lFile, 
				   unsigned long lLen, 
				   unsigned char cFileType, // DATA, COUNTER or KEY type
				   unsigned char cReadAccess, // required only for DATA and COUNTER files
				   unsigned char cWriteAccess, // required only for DATA and COUNTER files
				   unsigned char cCryptAccess, // required only for KEY files
				   unsigned long *plSysErr, char *sMsg);

#endif /* IKFILETOOL_HXX */
